# HG changeset patch
# User John Donoghue
# Date 1534536016 14400
#      Fri Aug 17 16:00:16 2018 -0400
# Node ID 5716f50b6a23639f3d71b790f66bb1cd25c3f5c1
# Parent  e3fe651408f9be941ea9eba2d768c34772a03101
Add msys2-perl

* src/msys2-perl.mk, src/src-msys2-perl.mk, src/msys2-libcrypt.mk,
src/src-msys2-libcrypt.mk: New files.

* dist-files.mk: Add new files.

* index.html: Add msys2-perl and msys2-libcrypt links.

diff -r e3fe651408f9 -r 5716f50b6a23 dist-files.mk
--- a/dist-files.mk	Fri Aug 17 13:57:05 2018 -0700
+++ b/dist-files.mk	Fri Aug 17 16:00:16 2018 -0400
@@ -909,6 +909,7 @@
   msys2-less.mk \
   msys2-libassuan.mk \
   msys2-libbz2.mk \
+  msys2-libcrypt.mk \
   msys2-libexpat.mk \
   msys2-libffi.mk \
   msys2-libgnutls.mk \
@@ -941,6 +942,7 @@
   msys2-pacman-mirrors.mk \
   msys2-pacman.mk \
   msys2-patch.mk \
+  msys2-perl.mk \
   msys2-runtime.mk \
   msys2-sed.mk \
   msys2-tar.mk \
@@ -971,6 +973,7 @@
   src-msys2-less.mk \
   src-msys2-libassuan.mk \
   src-msys2-libbz2.mk \
+  src-msys2-libcrypt.mk \
   src-msys2-libexpat.mk \
   src-msys2-libffi.mk \
   src-msys2-libgcrypt.mk \
@@ -1003,6 +1006,7 @@
   src-msys2-pacman-mirrors.mk \
   src-msys2-pacman.mk \
   src-msys2-patch.mk \
+  src-msys2-perl.mk \
   src-msys2-runtime.mk \
   src-msys2-sed.mk \
   src-msys2-tar.mk \
diff -r e3fe651408f9 -r 5716f50b6a23 index.html
--- a/index.html	Fri Aug 17 13:57:05 2018 -0700
+++ b/index.html	Fri Aug 17 16:00:16 2018 -0400
@@ -1946,6 +1946,10 @@
         <td class="website"><a href="https://www.msys2.org/">MSYS2 libbz2</a></td>
     </tr>
     <tr>
+        <td class="package">msys2-libcrypt</td>
+        <td class="website"><a href="https://www.msys2.org/">MSYS2 libcrypt</a></td>
+    </tr>
+    <tr>
         <td class="package">msys2-libexpat</td>
         <td class="website"><a href="https://www.msys2.org/">MSYS2 libexpat</a></td>
     </tr>
@@ -2074,6 +2078,10 @@
         <td class="website"><a href="https://www.msys2.org/">MSYS2 patch</a></td>
     </tr>
     <tr>
+        <td class="package">msys2-perl</td>
+        <td class="website"><a href="https://www.msys2.org/">MSYS2 perl</a></td>
+    </tr>
+    <tr>
         <td class="package">msys2-runtime</td>
         <td class="website"><a href="https://www.msys2.org/">MSYS2 runtime</a></td>
     </tr>
diff -r e3fe651408f9 -r 5716f50b6a23 src/msys2-libcrypt.mk
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/msys2-libcrypt.mk	Fri Aug 17 16:00:16 2018 -0400
@@ -0,0 +1,26 @@
+# This file is part of MXE.
+# See index.html for further information.
+
+PKG             := msys2-libcrypt
+$(PKG)_NAME     := libcrypt
+$(PKG)_IGNORE   :=
+$(PKG)_VERSION  := 2.1-2
+$(PKG)_x86_64_CS := 4e8b7747e8443209507811492bc560a2752064f3
+$(PKG)_i686_CS  :=
+$(PKG)_CS       := $($(PKG)_$(MSYS2_ARCH)_CS)
+$(PKG)_CHECKSUM := $($(PKG)_CS)
+$(PKG)_SUBDIR   := 
+$(PKG)_FILE     := $($(PKG)_NAME)-$($(PKG)_VERSION)-$(MSYS2_ARCH).pkg.tar.xz
+$(PKG)_URL      := $(MSYS2_URL)/$($(PKG)_FILE)/download
+
+$(PKG)_DEPS     := 
+
+define $(PKG)_UPDATE
+    $(WGET) -q -O- '$(MSYS2_BASE_URL)/' | \
+    $(SED) -n 's,.*title="$($(PKG)_NAME)-\([0-9][^"]*\)".*,\1,p' | \
+    head -1
+endef
+
+define $(PKG)_BUILD
+    $(MSYS2_PKG_BUILD)
+endef
diff -r e3fe651408f9 -r 5716f50b6a23 src/msys2-perl.mk
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/msys2-perl.mk	Fri Aug 17 16:00:16 2018 -0400
@@ -0,0 +1,26 @@
+# This file is part of MXE.
+# See index.html for further information.
+
+PKG             := msys2-perl
+$(PKG)_NAME     := perl
+$(PKG)_IGNORE   :=
+$(PKG)_VERSION  := 5.28.0-1
+$(PKG)_x86_64_CS := a13e73a18d0ec7e8dd564c6be98aae39284c0537
+$(PKG)_i686_CS  := ad79e3e489f1a36ab7b9138a9b2b2f571a14a924
+$(PKG)_CS       := $($(PKG)_$(MSYS2_ARCH)_CS)
+$(PKG)_CHECKSUM := $($(PKG)_CS)
+$(PKG)_SUBDIR   := 
+$(PKG)_FILE     := $($(PKG)_NAME)-$($(PKG)_VERSION)-$(MSYS2_ARCH).pkg.tar.xz
+$(PKG)_URL      := $(MSYS2_URL)/$($(PKG)_FILE)/download
+
+$(PKG)_DEPS     := msys2-libcrypt
+
+define $(PKG)_UPDATE
+    $(WGET) -q -O- '$(MSYS2_BASE_URL)/' | \
+    $(SED) -n 's,.*title="$($(PKG)_NAME)-\([0-9][^"]*\)".*,\1,p' | \
+    head -1
+endef
+
+define $(PKG)_BUILD
+    $(MSYS2_PKG_BUILD)
+endef
diff -r e3fe651408f9 -r 5716f50b6a23 src/src-msys2-libcrypt.mk
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/src-msys2-libcrypt.mk	Fri Aug 17 16:00:16 2018 -0400
@@ -0,0 +1,22 @@
+# This file is part of MXE.
+# See index.html for further information.
+
+PKG             := src-msys2-libcrypt
+$(PKG)_NAME     := libcrypt
+$(PKG)_IGNORE   :=
+$(PKG)_VERSION  := 2.1-2
+$(PKG)_CHECKSUM := d8ad56e97e77e1c0e35e5fe7a6650b69861bcc25
+$(PKG)_SUBDIR   := 
+$(PKG)_FILE     := $($(PKG)_NAME)-$($(PKG)_VERSION).src.tar.gz
+$(PKG)_URL      := $(MSYS2_SRC_URL)/$($(PKG)_FILE)/download
+
+$(PKG)_DEPS     := 
+
+define $(PKG)_UPDATE
+    $(WGET) -q -O- '$(MSYS2_BASE_URL)/' | \
+    $(SED) -n 's,.*title="$($(PKG)_NAME)-\([0-9][^"]*\)".*,\1,p' | \
+    head -1
+endef
+
+define $(PKG)_BUILD
+endef
diff -r e3fe651408f9 -r 5716f50b6a23 src/src-msys2-perl.mk
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/src-msys2-perl.mk	Fri Aug 17 16:00:16 2018 -0400
@@ -0,0 +1,22 @@
+# This file is part of MXE.
+# See index.html for further information.
+
+PKG             := src-msys2-perl
+$(PKG)_NAME     := perl
+$(PKG)_IGNORE   :=
+$(PKG)_VERSION  := 5.28.0-1
+$(PKG)_CHECKSUM := b8b6fad230ded81d0224e2fd9a7d532a7feef5ec
+$(PKG)_SUBDIR   := 
+$(PKG)_FILE     := $($(PKG)_NAME)-$($(PKG)_VERSION).src.tar.gz
+$(PKG)_URL      := $(MSYS2_SRC_URL)/$($(PKG)_FILE)/download
+
+$(PKG)_DEPS     := 
+
+define $(PKG)_UPDATE
+    $(WGET) -q -O- '$(MSYS2_BASE_URL)/' | \
+    $(SED) -n 's,.*title="$($(PKG)_NAME)-\([0-9][^"]*\)".*,\1,p' | \
+    head -1
+endef
+
+define $(PKG)_BUILD
+endef